From: Ole Streicher <olebole@debian.org>
Date: Sun, 24 Jan 2016 12:00:00 +0000
Subject: Create a shared library

Create a shared library to link to gdl executable and Python extension
The library is called libgnudatalanguage.so to avoid confusion with the
libgdl from the GNOME project.

Forwarded: https://sourceforge.net/p/gnudatalanguage/patches/95/
---
 CMakeLists.txt     |  6 +-----
 src/CMakeLists.txt | 39 +++++++++++++++++++++++----------------
 src/pythongdl.cpp  | 10 ++++++++++
 3 files changed, 34 insertions(+), 21 deletions(-)

diff --git a/CMakeLists.txt b/CMakeLists.txt
index 6c07596..cbacfda 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -1074,9 +1074,7 @@ endif(EXPAT)
 
 add_subdirectory(src)
 
-if(NOT PYTHON_MODULE)
-    add_subdirectory(testsuite)
-endif(NOT PYTHON_MODULE)
+add_subdirectory(testsuite)
 
 install(FILES ${CMAKE_SOURCE_DIR}/AUTHORS ${CMAKE_SOURCE_DIR}/README DESTINATION ${CMAKE_INSTALL_PREFIX}/${GDL_DATA_DIR})
 install(FILES ${CMAKE_SOURCE_DIR}/doc/gdl.1 DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)
@@ -1086,14 +1084,12 @@ configure_file(${CMAKE_SOURCE_DIR}/config.h.cmake ${CMAKE_BINARY_DIR}/config.h)
 
 # create a link src/gdl -> ${BUILD}/.../gdl
 # for windows, just copy the file
-if(NOT PYTHON_MODULE)
     set(GDLLOCATION $<TARGET_FILE:gdl>)
     if(WIN32)
     add_custom_target(copy_gdl ALL ${CMAKE_COMMAND} -E copy ${GDLLOCATION} ${CMAKE_SOURCE_DIR}/src/gdl DEPENDS gdl)
     else(WIN32)
     add_custom_target(symlink_gdl ALL ${CMAKE_COMMAND} -E create_symlink ${GDLLOCATION} ${CMAKE_SOURCE_DIR}/src/gdl DEPENDS gdl)
     endif(WIN32)
-endif(NOT PYTHON_MODULE)
 
 # display macro
 macro(MODULE MOD LIBNAME NAME)
diff --git a/src/CMakeLists.txt b/src/CMakeLists.txt
index f1923d2..1d296d3 100644
--- a/src/CMakeLists.txt
+++ b/src/CMakeLists.txt
@@ -198,27 +198,34 @@ add_subdirectory(antlr)
 include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/antlr ${CMAKE_BINARY_DIR})
 link_directories(${LINK_DIRECTORIES})
 
+add_library(gnudatalanguage SHARED ${SOURCES})
+SET_TARGET_PROPERTIES(gnudatalanguage PROPERTIES SOVERSION 0)
 if(PYTHON_MODULE) #GDL.so
-	add_library(gdl SHARED ${SOURCES})
-	SET_TARGET_PROPERTIES(gdl PROPERTIES PREFIX "")
-	SET_TARGET_PROPERTIES(gdl PROPERTIES OUTPUT_NAME GDL)
-	SET_TARGET_PROPERTIES(gdl PROPERTIES NO_SONAME TRUE)
-        SET_TARGET_PROPERTIES(gdl PROPERTIES SUFFIX ".so") # e.g. Mac defaults to .dylib which is not looked for by Python
-else(PYTHON_MODULE) #GDL.so
-	set(SOURCES ${SOURCES} gdl.cpp)
-	add_executable(gdl ${SOURCES})
+	add_library(pythongdl SHARED pythongdl.cpp)
+	SET_TARGET_PROPERTIES(pythongdl PROPERTIES PREFIX "")
+	SET_TARGET_PROPERTIES(pythongdl PROPERTIES OUTPUT_NAME GDL)
+	SET_TARGET_PROPERTIES(pythongdl PROPERTIES NO_SONAME TRUE)
+	target_link_libraries(pythongdl gnudatalanguage)
 endif(PYTHON_MODULE)
+add_executable(gdl gdl.cpp)
+target_link_libraries(gdl gnudatalanguage)
+if (OPENMP)
+	target_link_libraries(gdl -fopenmp)
+endif (OPENMP)
+if (READLINE)
+	target_link_libraries(gdl readline)
+endif (READLINE)
 
 if(USE_OPENMP)
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
 endif(USE_OPENMP)
 
-add_dependencies(gdl antlr) # be sure that antlr is built before gdl
-target_link_libraries(gdl antlr) # link antlr against gdl
+add_dependencies(gnudatalanguage antlr) # be sure that antlr is built before gdl
+target_link_libraries(gnudatalanguage antlr) # link antlr against gdl
 if (MINGW)
-target_link_libraries(gdl ws2_32)
+target_link_libraries(gnudatalanguage ws2_32)
 endif (MINGW)
-target_link_libraries(gdl ${LIBRARIES})
+target_link_libraries(gnudatalanguage ${LIBRARIES})
 add_definitions(-DHAVE_CONFIG_H)
 
 if(PYTHON_MODULE)
@@ -233,11 +240,11 @@ if(PYTHON_MODULE)
 	file( TO_CMAKE_PATH "${PYTHON_SITE_DIR}" PYTHON_SITE_DIR )
 	string( REGEX REPLACE "^${PYTHON_PREFIX}/" ""
 	       PYTHON_SITE_DIR "${PYTHON_SITE_DIR}")
-	install(TARGETS gdl DESTINATION ${PYTHON_SITE_DIR})
-else(PYTHON_MODULE)
-	install(TARGETS gdl DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
-	set_target_properties(gdl PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
+	install(TARGETS pythongdl DESTINATION ${PYTHON_SITE_DIR})
 endif(PYTHON_MODULE)
+install(TARGETS gdl DESTINATION bin)
+set_target_properties(gdl PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
+install(TARGETS gnudatalanguage DESTINATION lib)
 
 install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/pro/ DESTINATION ${CMAKE_INSTALL_PREFIX}/${GDL_DATA_DIR}/lib
 	PATTERN CVS EXCLUDE
diff --git a/src/pythongdl.cpp b/src/pythongdl.cpp
index 4150e5d..9a91b9b 100644
--- a/src/pythongdl.cpp
+++ b/src/pythongdl.cpp
@@ -45,6 +45,16 @@
 
 void LibInit(); // defined in libinit.cpp
 
+//initialize wxWidgets system
+#ifdef HAVE_LIBWXWIDGETS
+#include "gdlwidget.hpp"
+#ifndef __WXMAC__ 
+wxIMPLEMENT_APP_NO_MAIN( wxAppGDL);
+#else
+wxIMPLEMENT_APP_NO_MAIN( wxApp);
+#endif
+#endif
+
 using namespace std;
 
 // everything is executed within this interpreter
